unit Unit1;

interface

uses
  Windows, Messages, SysUtils, Variants, Classes, Graphics, Controls, Forms,
  Dialogs, TeeGDIPlus, TeEngine, Series, ExtCtrls, TeeProcs, Chart;

type
  TForm1 = class(TForm)
    Chart1: TChart;
    Series1: TBarSeries;
    Series2: TBarSeries;
    procedure Chart1Scroll(Sender: TObject);
    procedure Chart1MouseWheel(Sender: TObject; Shift: TShiftState;
      WheelDelta: Integer; MousePos: TPoint; var Handled: Boolean);
    procedure Chart1UndoZoom(Sender: TObject);
    procedure Chart1Zoom(Sender: TObject);
    procedure FormCreate(Sender: TObject);
    procedure Chart1AfterDraw(Sender: TObject);
  private
    { Private declarations }
    procedure PlaceComments;
  public
    { Public declarations }
  end;

var
  Form1: TForm1;

implementation

{$R *.dfm}

var mouseWheelChanged: boolean;

procedure TForm1.Chart1AfterDraw(Sender: TObject);
begin
  if mouseWheelChanged then
  begin
    mouseWheelChanged:=False;
    PlaceComments;
  end;
end;

procedure TForm1.Chart1MouseWheel(Sender: TObject; Shift: TShiftState;
  WheelDelta: Integer; MousePos: TPoint; var Handled: Boolean);
begin
  mouseWheelChanged:=True;
end;

procedure TForm1.Chart1Scroll(Sender: TObject);
begin
  PlaceComments;
end;

procedure TForm1.Chart1UndoZoom(Sender: TObject);
begin
  PlaceComments;
end;

procedure TForm1.Chart1Zoom(Sender: TObject);
begin
  PlaceComments;
end;

procedure TForm1.FormCreate(Sender: TObject);
var
  s : integer;
begin
  for s := 0 to Chart1.SeriesCount - 1 do
    Chart1[s].Marks.Arrow.Hide;

  mouseWheelChanged:=False;
  PlaceComments;
end;

procedure TForm1.PlaceComments;
var
  s, i, tmpSize, LIndex, LMarksHeight : integer;
  LComment: string;
  fBarWidth: Integer;
const
  fCommentStart=0;
begin
  Chart1.Draw;

  {with Chart1.Axes.Left do
       Caption:='Minimum: ' + FormatFloat(AxisValuesFormat, Minimum) + ', Maximum: ' + FormatFloat(AxisValuesFormat, Maximum);}

  fBarWidth:=(Chart1[0] as TBarSeries).BarWidth;

  for s := 0 to Chart1.SeriesCount - 1 do
    with TBarSeries(Chart1[s]) do
    begin
      for i := 0 to TBarSeries(Chart1[s]).Count - 1 do
      begin
        LComment:='Series ' + IntToStr(s) + ', ValueIndex: ' + IntToStr(i);
        with Marks.Positions[i] do
        begin
          Custom := true;
          LeftTop.X := CalcXPos(i) + fBarWidth + fCommentStart;
          tmpSize := CalcYSizeValue(YValue[i]);
          LMarksHeight := Marks.Height;
          LeftTop.Y := CalcYPos(i) + (tmpSize div 2) - (LMarksHeight div 2);
        end;
      end;
    end;

  Chart1.Draw;
end;
end.
